from typing import Any
from typing import List
from typing import Set
from typing import Tuple

from . import *


class FModifierGenerator(FModifier):
    
    # Coefficients for ‘x’ (starting from lowest power of x^0)
    coefficients: Tuple[float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float, float]
    
    # Type of generator to use
    mode: str = 'POLYNOMIAL' # ['POLYNOMIAL', 'POLYNOMIAL_FACTORISED']
    
    # The highest power of ‘x’ for this polynomial (number of coefficients - 1)
    poly_order: int
    
    # Values generated by this modifier are applied on top of the existing values instead of overwriting them
    use_additive: bool

    @classmethod
    def bl_rna_get_subclass(cls, *args, **kwargs) -> Struct:
        ...

    @classmethod
    def bl_rna_get_subclass_py(cls, *args, **kwargs) -> Any:
        ...